// post-note.ts

import { finishEvent, relayInit } from "npm:nostr-tools@1.14.2";

const privateKey = "(略)";

// パート➀: イベントを作成する

const event = {
  created_at: Math.floor(Date.now() / 1000), // 現在時刻を設定する
  kind: 1,
  tags: [],
  content: "Hello, nostr!",
};

const signedEvent = finishEvent(event, privateKey); // id と sig を計算する
console.log("event created: ", JSON.stringify(signedEvent));

// パート②: リレーに接続してイベントを送信する

const relay = relayInit("wss://nos.lol");

relay.on("connect", () => console.log(`connected to ${relay.url}`));
relay.on("error", () => console.log(`failed to connect to ${relay.url}`));

await relay.connect(); // リレーに接続する

await relay.publish(signedEvent); // イベントを送信する
console.log("event published");

await relay.close(); // リレーから切断する
console.log("disconnected from relay");
