// receive-and-validate.ts

import { verifySignature } from "npm:nostr-tools@1.14.2";

const ws = new WebSocket("wss://nos.lol");

ws.addEventListener("open", () => { // 接続できた
  console.log("connection opened, sending REQ");
  const req = [
    "REQ",
    "bar",
    {
      kinds: [1],
      authors: [
        "9c163c7351f8832b08b56cbb2e095960d1c5060dd6b0e461e813f0f07459119e",
      ],
      limit: 1,
    },
  ];
  ws.send(JSON.stringify(req)); // リレーにREQを送信する
});

ws.addEventListener("message", (event) => { // メッセージを受信した
  console.log("message received", event.data);
  const message = JSON.parse(event.data);
  if (message[0] === "EVENT") { // EVENTを受信した場合
    const isVerified = verifySignature(message[2]); // 署名を検証する
    console.log("is verified?", isVerified);
  } else if (message[0] === "EOSE") { // EOSEを受信した場合
    ws.close(); // WebSocketを切断して終了する
  }
});

ws.addEventListener("close", () => console.log("connection closed"));
ws.addEventListener("error", (event) => console.error(event));
