// rx-nostr-example.ts

import {
  createRxForwardReq,
  createRxNostr,
  now,
  uniq,
  verify,
} from "npm:rx-nostr@1.8.0";

const rxNostr = createRxNostr();
await rxNostr.switchRelays(["wss://nos.lol", "wss://relay.damus.io"]);

const rxReq = createRxForwardReq();
rxNostr
  .use(rxReq)
  .pipe(
    verify(), // イベントを検証する
    uniq() // 重複を除去する
  )
  .subscribe(({ event }) => console.log(event));

rxReq.emit({ kinds: [1], since: now() }); // 今後の投稿（kind 1）を取得する
